package rocks.zipcode.io.quiz3.generics;


import java.lang.reflect.Array;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * @author leon on 09/12/2018.
 */
public class ArrayUtility<SomeType> {
    private final SomeType[] array;

    public ArrayUtility(SomeType[] array) {
        this.array = array;
    }

    public SomeType findOddOccurringValue() {
        Map<SomeType, Integer> map = new HashMap<>();
        SomeType result= null;
        for (int i = 0; i < array.length; i++) {
            if (map.containsKey(array[i])){
                map.put(array[i], map.get(array[i]) + 1);
            } else {
                map.put(array[i], 1);
            }
        }
        for (Map.Entry<SomeType, Integer> entry: map.entrySet()){
            if (entry.getValue() % 2 != 0){
                result = entry.getKey();
            }
        }
        return result;
    }

    public SomeType findEvenOccurringValue() {
        Map<SomeType, Integer> map = new HashMap<>();
        SomeType result = null;
        for (int i = 0; i < array.length; i++) {
            if (map.containsKey(array[i])) {
                map.put(array[i], map.get(array[i]) + 1);
            } else {
                map.put(array[i], 1);
            }
        }
        for (Map.Entry<SomeType, Integer> entry : map.entrySet()) {
            if (entry.getValue() % 2 == 0) {
                result = entry.getKey();
            }
        }
        return result;
    }

    public Integer getNumberOfOccurrences(SomeType valueToEvaluate) {
        Integer occurrences = 0;
        for (SomeType each: array){
            if(each.equals(valueToEvaluate)){
                occurrences++;
            }
        }
        return occurrences;
    }

    public SomeType[] filter(Function<SomeType, Boolean> predicate) {
        return null;
    }
}
