package rocks.zipcode.io.quiz3.collections;

import rocks.zipcode.io.quiz3.objectorientation.enums.LabStatus;

import java.util.HashMap;
import java.util.Map;

/**
 * @author leon on 10/12/2018.
 */
public class Student {
    private Map<Lab, LabStatus> map;

    public Student() {
        map = new HashMap<>();
    }

    public Student(Map<Lab, LabStatus> map) {
        this.map = map;
    }

    public void setLabStatus(Lab lab, LabStatus labStatus) {
       if (this.map.containsKey(lab)){
           this.map.replace(lab, labStatus);
       } else{
           throw new UnsupportedOperationException();
       }
    }


    public void forkLab(Lab lab) {
       this.map.put(lab, LabStatus.PENDING);
    }

    public LabStatus getLabStatus(String labName) {
        for (Lab each: map.keySet()){
            if (each.getName().equals(labName)){
                return each.getLabStatus();
            }
        }
        return null;
    }

    @Override
    public String toString() {
        return "buh";
    }
}
